
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Timer.vec"
	.INCLUDE "Timer.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.8 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : Timer
;       9 Version : 1.0
;      10 Date    : 03.05.2009
;      11 Author  : AlexeyN
;      12 Company : HomeLab
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega8
;      17 Program type        : Application
;      18 Clock frequency     : 8,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 
;      24 #include <mega8.h>
;      25 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      26 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      27 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      28 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      29 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      30 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      31 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      32 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      33 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      34 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      35 	#endif
	#endif
;      36 #include <delay.h>
;      37 #include <stdio.h>
;      38 
;      39 char secnd=0;
;      40 char minut=1;
;      41 char hours=0;
;      42 
;      43 bit start=0;
;      44 bit lamp=0;
;      45 bit beep=0;
;      46 bit sound=0;
;      47 bit pump=0;
;      48 
;      49 char timr;
;      50 char tm=150;
;      51 
;      52 char vadr=0;
;      53 char vdat[8];
_vdat:
	.BYTE 0x8
;      54 static char str[9];
_str_G1:
	.BYTE 0x9
;      55 
;      56 // Timer 0 overflow interrupt service routine
;      57 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      58 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      59 // Place your code here
;      60 PORTD=0;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;      61 PORTB=vadr+(lamp<<5)+(sound<<3)+(pump<<4);
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	ADD  R30,R8
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,3
	LDI  R30,1
	LSL  R30
	LSL  R30
	LSL  R30
	ADD  R26,R30
	LDI  R30,0
	SBRC R2,4
	LDI  R30,1
	SWAP R30
	ANDI R30,0xF0
	ADD  R30,R26
	OUT  0x18,R30
;      62 PORTD=vdat[vadr];
	MOV  R30,R8
	LDI  R31,0
	SUBI R30,LOW(-_vdat)
	SBCI R31,HIGH(-_vdat)
	LD   R30,Z
	OUT  0x12,R30
;      63 
;      64 vadr++;
	INC  R8
;      65 if(vadr==8)vadr=0;
	LDI  R30,LOW(8)
	CP   R30,R8
	BRNE _0x5
	CLR  R8
;      66 if(PINC<255)timr++;
_0x5:
	IN   R30,0x13
	CPI  R30,LOW(0xFF)
	BRSH _0x6
	INC  R6
;      67 if(PINC==255)timr=0;
_0x6:
	IN   R30,0x13
	CPI  R30,LOW(0xFF)
	BRNE _0x7
	CLR  R6
;      68 if(beep==1)sound++;
_0x7:
	SBRS R2,2
	RJMP _0x8
	LDI  R30,LOW(8)
	EOR  R2,R30
;      69 }
_0x8:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;      70 
;      71 // Timer 1 output compare A interrupt service routine
;      72 interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;      73 {
_timer1_compa_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      74 // Place your code here
;      75        TCNT1H=0;
	RCALL SUBOPT_0x0
;      76        TCNT1L=0;
;      77 secnd--;
	DEC  R5
;      78 
;      79 if(secnd==255)
	LDI  R30,LOW(255)
	CP   R30,R5
	BRNE _0x9
;      80 {
;      81 secnd=59;
	LDI  R30,LOW(59)
	MOV  R5,R30
;      82 minut--;
	DEC  R4
;      83 };
_0x9:
;      84 
;      85 if(minut==255)
	LDI  R30,LOW(255)
	CP   R30,R4
	BRNE _0xA
;      86 {
;      87 minut=59;
	LDI  R30,LOW(59)
	MOV  R4,R30
;      88 hours--;
	DEC  R7
;      89 };
_0xA:
;      90 
;      91 if(hours==255)hours=23;
	LDI  R30,LOW(255)
	CP   R30,R7
	BRNE _0xB
	LDI  R30,LOW(23)
	MOV  R7,R30
;      92 
;      93 }
_0xB:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;      94 
;      95 // Declare your global variables here
;      96 
;      97 char getCode (char ch)
;      98 {
_getCode:
;      99     switch (ch)
;	ch -> Y+0
	LD   R30,Y
;     100     {   case '0': return  63;  // "0"
	CPI  R30,LOW(0x30)
	BRNE _0xF
	LDI  R30,LOW(63)
	RJMP _0x10A
;     101         case '1': return  6;   // "1"
_0xF:
	CPI  R30,LOW(0x31)
	BRNE _0x10
	LDI  R30,LOW(6)
	RJMP _0x10A
;     102         case '2': return  91;  // "2"
_0x10:
	CPI  R30,LOW(0x32)
	BRNE _0x11
	LDI  R30,LOW(91)
	RJMP _0x10A
;     103         case '3': return  79;  // "3"
_0x11:
	CPI  R30,LOW(0x33)
	BRNE _0x12
	LDI  R30,LOW(79)
	RJMP _0x10A
;     104         case '4': return  102; // "4"
_0x12:
	CPI  R30,LOW(0x34)
	BRNE _0x13
	LDI  R30,LOW(102)
	RJMP _0x10A
;     105         case '5': return  109; // "5"
_0x13:
	CPI  R30,LOW(0x35)
	BRNE _0x14
	LDI  R30,LOW(109)
	RJMP _0x10A
;     106         case '6': return  125; // "6"
_0x14:
	CPI  R30,LOW(0x36)
	BRNE _0x15
	LDI  R30,LOW(125)
	RJMP _0x10A
;     107         case '7': return  7;   // "7"
_0x15:
	CPI  R30,LOW(0x37)
	BRNE _0x16
	LDI  R30,LOW(7)
	RJMP _0x10A
;     108         case '8': return  127; // "8"
_0x16:
	CPI  R30,LOW(0x38)
	BRNE _0x17
	LDI  R30,LOW(127)
	RJMP _0x10A
;     109         case '9': return  111; // "9"
_0x17:
	CPI  R30,LOW(0x39)
	BRNE _0x18
	LDI  R30,LOW(111)
	RJMP _0x10A
;     110         case '-': return  64;  // "-"
_0x18:
	CPI  R30,LOW(0x2D)
	BRNE _0x19
	LDI  R30,LOW(64)
	RJMP _0x10A
;     111         case ' ': return  0;   // " "
_0x19:
	CPI  R30,LOW(0x20)
	BRNE _0x1A
	LDI  R30,LOW(0)
	RJMP _0x10A
;     112         case '%': return  36;  // " "
_0x1A:
	CPI  R30,LOW(0x25)
	BRNE _0x1B
	LDI  R30,LOW(36)
	RJMP _0x10A
;     113         case 'e': return  121; // "E"
_0x1B:
	CPI  R30,LOW(0x65)
	BRNE _0x1C
	LDI  R30,LOW(121)
	RJMP _0x10A
;     114         case 'f': return  113; // "F"
_0x1C:
	CPI  R30,LOW(0x66)
	BRNE _0x1D
	LDI  R30,LOW(113)
	RJMP _0x10A
;     115         case 'S': return  109; // "S"
_0x1D:
	CPI  R30,LOW(0x53)
	BRNE _0x1E
	LDI  R30,LOW(109)
	RJMP _0x10A
;     116         case 't': return  120; // "t"
_0x1E:
	CPI  R30,LOW(0x74)
	BRNE _0x1F
	LDI  R30,LOW(120)
	RJMP _0x10A
;     117         case '': return  99;  // ""
_0x1F:
	CPI  R30,LOW(0xB0)
	BRNE _0x20
	LDI  R30,LOW(99)
	RJMP _0x10A
;     118         case 'i': return  16;  // "i"
_0x20:
	CPI  R30,LOW(0x69)
	BRNE _0x21
	LDI  R30,LOW(16)
	RJMP _0x10A
;     119         case 'u': return  28;  // "u"
_0x21:
	CPI  R30,LOW(0x75)
	BRNE _0x22
	LDI  R30,LOW(28)
	RJMP _0x10A
;     120         case 'U': return  62;  // "U"
_0x22:
	CPI  R30,LOW(0x55)
	BRNE _0x23
	LDI  R30,LOW(62)
	RJMP _0x10A
;     121         case 'p': return  115; // "p"
_0x23:
	CPI  R30,LOW(0x70)
	BRNE _0x24
	LDI  R30,LOW(115)
	RJMP _0x10A
;     122         case 'h': return  116; // "h"
_0x24:
	CPI  R30,LOW(0x68)
	BRNE _0x25
	LDI  R30,LOW(116)
	RJMP _0x10A
;     123         case 'H': return  118; // "H"
_0x25:
	CPI  R30,LOW(0x48)
	BRNE _0x26
	LDI  R30,LOW(118)
	RJMP _0x10A
;     124         case 'o': return  92;  // "o"
_0x26:
	CPI  R30,LOW(0x6F)
	BRNE _0x27
	LDI  R30,LOW(92)
	RJMP _0x10A
;     125         case 'r': return  80;  // "r"
_0x27:
	CPI  R30,LOW(0x72)
	BRNE _0x28
	LDI  R30,LOW(80)
	RJMP _0x10A
;     126         case 'm': return  84;  // "m"
_0x28:
	CPI  R30,LOW(0x6D)
	BRNE _0x29
	LDI  R30,LOW(84)
	RJMP _0x10A
;     127         case 'n': return  84;  // "n"
_0x29:
	CPI  R30,LOW(0x6E)
	BRNE _0x2A
	LDI  R30,LOW(84)
	RJMP _0x10A
;     128         case 'c': return  88;  // "c"
_0x2A:
	CPI  R30,LOW(0x63)
	BRNE _0x2B
	LDI  R30,LOW(88)
	RJMP _0x10A
;     129         case 'C': return  57;  // "C"
_0x2B:
	CPI  R30,LOW(0x43)
	BRNE _0x2C
	LDI  R30,LOW(57)
	RJMP _0x10A
;     130         case 'd': return  94;  // "d"
_0x2C:
	CPI  R30,LOW(0x64)
	BRNE _0x2D
	LDI  R30,LOW(94)
	RJMP _0x10A
;     131         case 'a': return  119;  // "a"
_0x2D:
	CPI  R30,LOW(0x61)
	BRNE _0x2E
	LDI  R30,LOW(119)
	RJMP _0x10A
;     132         case 'y': return  110;  // "y"
_0x2E:
	CPI  R30,LOW(0x79)
	BRNE _0x2F
	LDI  R30,LOW(110)
	RJMP _0x10A
;     133         case '': return  0;  // " "
_0x2F:
	CPI  R30,0
	BRNE _0xE
	LDI  R30,LOW(0)
	RJMP _0x10A
;     134 
;     135     }
_0xE:
;     136 return 1;
	LDI  R30,LOW(1)
_0x10A:
	ADIW R28,1
	RET
;     137 }
;     138 
;     139 void main(void)
;     140 {
_main:
;     141 // Declare your local variables here
;     142 char i;
;     143 
;     144 // Input/Output Ports initialization
;     145 // Port B initialization
;     146 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     147 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     148 PORTB=0x00;
;	i -> R17
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     149 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
;     150 
;     151 // Port C initialization
;     152 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     153 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     154 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     155 DDRC=0x00;
	OUT  0x14,R30
;     156 
;     157 // Port D initialization
;     158 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     159 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     160 PORTD=0x00;
	OUT  0x12,R30
;     161 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     162 
;     163 // Timer/Counter 0 initialization
;     164 // Clock source: System Clock
;     165 // Clock value: 1000,000 kHz
;     166 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     167 TCNT0=0x00;
	OUT  0x32,R30
;     168 
;     169 // Timer/Counter 1 initialization
;     170 // Clock source: System Clock
;     171 // Clock value: 7,813 kHz
;     172 // Mode: Normal top=FFFFh
;     173 // OC1A output: Discon.
;     174 // OC1B output: Discon.
;     175 // Noise Canceler: Off
;     176 // Input Capture on Falling Edge
;     177 // Timer 1 Overflow Interrupt: Off
;     178 // Input Capture Interrupt: Off
;     179 // Compare A Match Interrupt: On
;     180 // Compare B Match Interrupt: Off
;     181 TCCR1A=0x00;
	OUT  0x2F,R30
;     182 TCCR1B=0x00;
	OUT  0x2E,R30
;     183 TCNT1H=0x00;
	RCALL SUBOPT_0x0
;     184 TCNT1L=0x00;
;     185 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
;     186 ICR1L=0x00;
	OUT  0x26,R30
;     187 OCR1AH=0x1E;
	LDI  R30,LOW(30)
	OUT  0x2B,R30
;     188 OCR1AL=0x85;
	LDI  R30,LOW(133)
	OUT  0x2A,R30
;     189 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     190 OCR1BL=0x00;
	OUT  0x28,R30
;     191 
;     192 // Timer/Counter 2 initialization
;     193 // Clock source: System Clock
;     194 // Clock value: Timer 2 Stopped
;     195 // Mode: Phase correct PWM top=FFh
;     196 // OC2 output: Non-Inverted PWM
;     197 ASSR=0x00;
	OUT  0x22,R30
;     198 TCCR2=0x00;//TCCR2=0x60;
	OUT  0x25,R30
;     199 TCNT2=0x00;
	OUT  0x24,R30
;     200 OCR2=0x00;
	OUT  0x23,R30
;     201 
;     202 // External Interrupt(s) initialization
;     203 // INT0: Off
;     204 // INT1: Off
;     205 MCUCR=0x00;
	OUT  0x35,R30
;     206 
;     207 // Timer(s)/Counter(s) Interrupt(s) initialization
;     208 TIMSK=0x11;
	LDI  R30,LOW(17)
	OUT  0x39,R30
;     209 
;     210 // Analog Comparator initialization
;     211 // Analog Comparator: Off
;     212 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     213 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     214 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     215 
;     216 // Global enable interrupts
;     217 #asm("sei")
	sei
;     218  TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     219 while (1)
_0x31:
;     220       {
;     221       // Place your code here
;     222 
;     223 
;     224 
;     225           sprintf (str,"%2d-%2d-%2d",hours,minut,secnd);
	LDI  R30,LOW(_str_G1)
	LDI  R31,HIGH(_str_G1)
	RCALL SUBOPT_0x1
	__POINTW1FN _0,0
	RCALL SUBOPT_0x1
	MOV  R30,R7
	RCALL SUBOPT_0x2
	MOV  R30,R4
	RCALL SUBOPT_0x2
	MOV  R30,R5
	RCALL SUBOPT_0x2
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     226 
;     227           if (str[0]==' ')str[0]='0';
	LDS  R26,_str_G1
	CPI  R26,LOW(0x20)
	BRNE _0x34
	LDI  R30,LOW(48)
	STS  _str_G1,R30
;     228           if (str[3]==' ')str[3]='0';
_0x34:
	__GETB1MN _str_G1,3
	CPI  R30,LOW(0x20)
	BRNE _0x35
	LDI  R30,LOW(48)
	__PUTB1MN _str_G1,3
;     229           if (str[6]==' ')str[6]='0';
_0x35:
	__GETB1MN _str_G1,6
	CPI  R30,LOW(0x20)
	BRNE _0x36
	LDI  R30,LOW(48)
	__PUTB1MN _str_G1,6
;     230 
;     231           for(i=0;i<=11;i++)
_0x36:
	LDI  R17,LOW(0)
_0x38:
	CPI  R17,12
	BRSH _0x39
;     232           {
;     233           vdat[i]=getCode(str[i]);
	MOV  R30,R17
	LDI  R31,0
	MOVW R26,R30
	SUBI R30,LOW(-_vdat)
	SBCI R31,HIGH(-_vdat)
	PUSH R31
	PUSH R30
	MOVW R30,R26
	SUBI R30,LOW(-_str_G1)
	SBCI R31,HIGH(-_str_G1)
	LD   R30,Z
	ST   -Y,R30
	RCALL _getCode
	POP  R26
	POP  R27
	ST   X,R30
;     234           };
	SUBI R17,-1
	RJMP _0x38
_0x39:
;     235 
;     236           if (start==0)
	SBRC R2,0
	RJMP _0x3A
;     237           {
;     238                if (PINB.6==0)
	SBIC 0x16,6
	RJMP _0x3B
;     239                {
;     240                 pump=1;
	SET
	BLD  R2,4
;     241                 delay_ms(5000);
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	RCALL SUBOPT_0x1
	RCALL _delay_ms
;     242                 pump=0;
	CLT
	BLD  R2,4
;     243                 timr=0;
	CLR  R6
;     244                 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     245                 lamp=1;
	SET
	BLD  R2,1
;     246                 start=1;
	BLD  R2,0
;     247                 beep=0;
	CLT
	BLD  R2,2
;     248                };
_0x3B:
;     249 
;     250                if(PINC.0==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,0
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x3C
;     251                {
;     252                timr=0;
	CLR  R6
;     253                hours++;
	INC  R7
;     254                };
_0x3C:
;     255 
;     256                if(PINC.1==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,1
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x3D
;     257                {
;     258                timr=0;
	CLR  R6
;     259                hours--;
	DEC  R7
;     260                };
_0x3D:
;     261 
;     262                if(PINC.2==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,2
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x3E
;     263                {
;     264                timr=0;
	CLR  R6
;     265                minut++;
	INC  R4
;     266                };
_0x3E:
;     267 
;     268                if(PINC.3==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,3
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x3F
;     269                {
;     270                timr=0;
	CLR  R6
;     271                minut--;
	DEC  R4
;     272                };
_0x3F:
;     273 
;     274                if(PINC.4==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,4
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x40
;     275                {
;     276                timr=0;
	CLR  R6
;     277                secnd++;
	INC  R5
;     278                };
_0x40:
;     279 
;     280                if(PINC.5==0 & timr==tm)
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	RCALL SUBOPT_0x3
	BREQ _0x41
;     281                {
;     282                timr=0;
	CLR  R6
;     283                secnd--;
	DEC  R5
;     284                };
_0x41:
;     285 
;     286                if(hours==24)hours=23;
	LDI  R30,LOW(24)
	CP   R30,R7
	BRNE _0x42
	LDI  R30,LOW(23)
	MOV  R7,R30
;     287                if(hours==255)hours=0;
_0x42:
	LDI  R30,LOW(255)
	CP   R30,R7
	BRNE _0x43
	CLR  R7
;     288                if(minut==60)minut=59;
_0x43:
	LDI  R30,LOW(60)
	CP   R30,R4
	BRNE _0x44
	LDI  R30,LOW(59)
	MOV  R4,R30
;     289                if(minut==255)minut=0;
_0x44:
	LDI  R30,LOW(255)
	CP   R30,R4
	BRNE _0x45
	CLR  R4
;     290                if(secnd==60)secnd=59;
_0x45:
	LDI  R30,LOW(60)
	CP   R30,R5
	BRNE _0x46
	LDI  R30,LOW(59)
	MOV  R5,R30
;     291                if(secnd==255)secnd=0;
_0x46:
	LDI  R30,LOW(255)
	CP   R30,R5
	BRNE _0x47
	CLR  R5
;     292           };
_0x47:
_0x3A:
;     293           if (start==1)
	SBRS R2,0
	RJMP _0x48
;     294           {
;     295                if(hours==0 & minut==0 & secnd==0)
	MOV  R26,R7
	LDI  R30,LOW(0)
	RCALL __EQB12
	MOV  R0,R30
	MOV  R26,R4
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R0,R30
	MOV  R26,R5
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0x49
;     296                {
;     297                start=0;
	RCALL SUBOPT_0x4
;     298                lamp=0;
;     299                beep=1;
	SET
	BLD  R2,2
;     300                TCCR1B=0x00;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
;     301                };
_0x49:
;     302 
;     303                if(PINB.7==0)
	SBIC 0x16,7
	RJMP _0x4A
;     304                {
;     305                timr=0;
	CLR  R6
;     306                start=0;
	RCALL SUBOPT_0x4
;     307                lamp=0;
;     308                TCCR1B=0x00;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
;     309                tm++;
	INC  R9
;     310                };
_0x4A:
;     311           };
_0x48:
;     312 
;     313       };
	RJMP _0x31
;     314 };
_0x4B:
	RJMP _0x4B

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x59
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x5B
	__CPWRN 16,17,2
	BRLO _0x5C
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x5B:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x5C:
	RJMP _0x5D
_0x59:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x5D:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x5E:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x60
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x64
	CPI  R18,37
	BRNE _0x65
	LDI  R17,LOW(1)
	RJMP _0x66
_0x65:
	RCALL SUBOPT_0x5
_0x66:
	RJMP _0x63
_0x64:
	CPI  R30,LOW(0x1)
	BRNE _0x67
	CPI  R18,37
	BRNE _0x68
	RCALL SUBOPT_0x5
	RJMP _0x10B
_0x68:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x69
	LDI  R16,LOW(1)
	RJMP _0x63
_0x69:
	CPI  R18,43
	BRNE _0x6A
	LDI  R20,LOW(43)
	RJMP _0x63
_0x6A:
	CPI  R18,32
	BRNE _0x6B
	LDI  R20,LOW(32)
	RJMP _0x63
_0x6B:
	RJMP _0x6C
_0x67:
	CPI  R30,LOW(0x2)
	BRNE _0x6D
_0x6C:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x6E
	ORI  R16,LOW(128)
	RJMP _0x63
_0x6E:
	RJMP _0x6F
_0x6D:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x63
_0x6F:
	CPI  R18,48
	BRLO _0x72
	CPI  R18,58
	BRLO _0x73
_0x72:
	RJMP _0x71
_0x73:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x63
_0x71:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x77
	RCALL SUBOPT_0x6
	LD   R30,X
	RCALL SUBOPT_0x7
	RJMP _0x78
_0x77:
	CPI  R30,LOW(0x73)
	BRNE _0x7A
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x7B
_0x7A:
	CPI  R30,LOW(0x70)
	BRNE _0x7D
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x7B:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x7E
_0x7D:
	CPI  R30,LOW(0x64)
	BREQ _0x81
	CPI  R30,LOW(0x69)
	BRNE _0x82
_0x81:
	ORI  R16,LOW(4)
	RJMP _0x83
_0x82:
	CPI  R30,LOW(0x75)
	BRNE _0x84
_0x83:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x9
	LDI  R17,LOW(5)
	RJMP _0x85
_0x84:
	CPI  R30,LOW(0x58)
	BRNE _0x87
	ORI  R16,LOW(8)
	RJMP _0x88
_0x87:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xB9
_0x88:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x9
	LDI  R17,LOW(4)
_0x85:
	SBRS R16,2
	RJMP _0x8A
	RCALL SUBOPT_0x6
	RCALL __GETW1P
	RCALL SUBOPT_0xA
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x8B
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0xA
	LDI  R20,LOW(45)
_0x8B:
	CPI  R20,0
	BREQ _0x8C
	SUBI R17,-LOW(1)
	RJMP _0x8D
_0x8C:
	ANDI R16,LOW(251)
_0x8D:
	RJMP _0x8E
_0x8A:
	RCALL SUBOPT_0x6
	RCALL __GETW1P
	RCALL SUBOPT_0xA
_0x8E:
_0x7E:
	SBRC R16,0
	RJMP _0x8F
_0x90:
	CP   R17,R21
	BRSH _0x92
	SBRS R16,7
	RJMP _0x93
	SBRS R16,2
	RJMP _0x94
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x95
_0x94:
	LDI  R18,LOW(48)
_0x95:
	RJMP _0x96
_0x93:
	LDI  R18,LOW(32)
_0x96:
	RCALL SUBOPT_0x5
	SUBI R21,LOW(1)
	RJMP _0x90
_0x92:
_0x8F:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x97
_0x98:
	CPI  R19,0
	BREQ _0x9A
	SBRS R16,3
	RJMP _0x9B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x9
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x10C
_0x9B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x10C:
	ST   -Y,R30
	RCALL SUBOPT_0xB
	CPI  R21,0
	BREQ _0x9D
	SUBI R21,LOW(1)
_0x9D:
	SUBI R19,LOW(1)
	RJMP _0x98
_0x9A:
	RJMP _0x9E
_0x97:
_0xA0:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x9
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0xA2:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0xA4
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0xA
	RJMP _0xA2
_0xA4:
	CPI  R18,58
	BRLO _0xA5
	SBRS R16,3
	RJMP _0xA6
	SUBI R18,-LOW(7)
	RJMP _0xA7
_0xA6:
	SUBI R18,-LOW(39)
_0xA7:
_0xA5:
	SBRC R16,4
	RJMP _0xA9
	CPI  R18,49
	BRSH _0xAB
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0xAA
_0xAB:
	RJMP _0x10D
_0xAA:
	CP   R21,R19
	BRLO _0xAF
	SBRS R16,0
	RJMP _0xB0
_0xAF:
	RJMP _0xAE
_0xB0:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0xB1
	LDI  R18,LOW(48)
_0x10D:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xB2
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0xB
	CPI  R21,0
	BREQ _0xB3
	SUBI R21,LOW(1)
_0xB3:
_0xB2:
_0xB1:
_0xA9:
	RCALL SUBOPT_0x5
	CPI  R21,0
	BREQ _0xB4
	SUBI R21,LOW(1)
_0xB4:
_0xAE:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0xA1
	RJMP _0xA0
_0xA1:
_0x9E:
	SBRS R16,0
	RJMP _0xB5
_0xB6:
	CPI  R21,0
	BREQ _0xB8
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x7
	RJMP _0xB6
_0xB8:
_0xB5:
_0xB9:
_0x78:
_0x10B:
	LDI  R17,LOW(0)
_0x63:
	RJMP _0x5E
_0x60:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x1
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x1
	RCALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S47:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(0)
	RCALL __EQB12
	MOV  R0,R30
	MOV  R30,R9
	MOV  R26,R6
	RCALL __EQB12
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	CLT
	BLD  R2,0
	BLD  R2,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x5:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x1
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x1
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x1
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x1
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x1
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x1
	RJMP __put_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
