/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Timer
Version : 1.0
Date    : 03.05.2009
Author  : AlexeyN                         
Company : HomeLab                         
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



char secnd=0;
char minut=1;
char hours=0;

bit start=0;
bit lamp=0;
bit beep=0;
bit sound=0;
bit pump=0;

char timr;
char tm=150;

char vadr=0;
char vdat[8];
static char str[9];

// Timer 0 overflow interrupt service routine
interrupt [10] void timer0_ovf_isr(void)
{
// Place your code here
PORTD=0;
PORTB=vadr+(lamp<<5)+(sound<<3)+(pump<<4);
PORTD=vdat[vadr];

vadr++;
if(vadr==8)vadr=0;
if(PINC<255)timr++;
if(PINC==255)timr=0;
if(beep==1)sound++;
}

// Timer 1 output compare A interrupt service routine
interrupt [7] void timer1_compa_isr(void)
{
// Place your code here
       TCNT1H=0;
       TCNT1L=0;
secnd--;

if(secnd==255)
{
secnd=59;
minut--;
};

if(minut==255)
{
minut=59;
hours--;
};

if(hours==255)hours=23;

}

// Declare your global variables here

char getCode (char ch)
{                                                                               
    switch (ch)
    {   case '0': return  63;  // "0"
        case '1': return  6;   // "1"
        case '2': return  91;  // "2"
        case '3': return  79;  // "3"
        case '4': return  102; // "4"
        case '5': return  109; // "5"
        case '6': return  125; // "6"
        case '7': return  7;   // "7"
        case '8': return  127; // "8"
        case '9': return  111; // "9"
        case '-': return  64;  // "-"
        case ' ': return  0;   // " "
        case '%': return  36;  // " "
        case 'e': return  121; // "E"
        case 'f': return  113; // "F"
        case 'S': return  109; // "S"
        case 't': return  120; // "t"
        case '': return  99;  // ""
        case 'i': return  16;  // "i"
        case 'u': return  28;  // "u"
        case 'U': return  62;  // "U"
        case 'p': return  115; // "p"
        case 'h': return  116; // "h"
        case 'H': return  118; // "H"
        case 'o': return  92;  // "o"
        case 'r': return  80;  // "r"
        case 'm': return  84;  // "m"
        case 'n': return  84;  // "n"
        case 'c': return  88;  // "c"
        case 'C': return  57;  // "C"
        case 'd': return  94;  // "d"
        case 'a': return  119;  // "a"
        case 'y': return  110;  // "y"
        case '': return  0;  // " "

    }
return 1;
}

void main(void)
{
// Declare your local variables here
char i;

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0x3F;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Phase correct PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x00;//TCCR2=0x60;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x11;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")
 TCCR0=0x03;
while (1)
      {
      // Place your code here
      
      

          sprintf (str,"%2d-%2d-%2d",hours,minut,secnd);
          
          if (str[0]==' ')str[0]='0';
          if (str[3]==' ')str[3]='0';
          if (str[6]==' ')str[6]='0';
          
          for(i=0;i<=11;i++)
          {
          vdat[i]=getCode(str[i]);
          };
          
          if (start==0)
          {
               if (PINB.6==0)
               {
                pump=1;
                delay_ms(5000);
                pump=0;
                timr=0;
                TCCR1B=0x05;
                lamp=1;
                start=1;
                beep=0;
               };
               
               if(PINC.0==0 & timr==tm)
               {
               timr=0;
               hours++;
               };
               
               if(PINC.1==0 & timr==tm)
               {
               timr=0;
               hours--;
               };
               
               if(PINC.2==0 & timr==tm)
               {
               timr=0;
               minut++;
               };
               
               if(PINC.3==0 & timr==tm)
               {
               timr=0;
               minut--;
               };
               
               if(PINC.4==0 & timr==tm)
               {
               timr=0;
               secnd++;
               };
               
               if(PINC.5==0 & timr==tm)
               {
               timr=0;
               secnd--;
               };
               
               if(hours==24)hours=23;
               if(hours==255)hours=0;
               if(minut==60)minut=59;
               if(minut==255)minut=0;
               if(secnd==60)secnd=59;
               if(secnd==255)secnd=0;
          };
          if (start==1)
          {
               if(hours==0 & minut==0 & secnd==0)
               {
               start=0;
               lamp=0;
               beep=1;
               TCCR1B=0x00;
               };
               
               if(PINB.7==0)
               {
               timr=0;
               start=0;
               lamp=0;
               TCCR1B=0x00;
               tm++;
               };
          };
          
      };
};
