/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Timer
Version : 1.0
Date    : 03.05.2009
Author  : AlexeyN
Company : HomeLab
Comments:


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>

char secnd=0;
char minut=1;
char hours=0;

bit start=0;
bit lamp=0;
bit beep=0;
bit sound=0;
bit pump=0;

char timr;
char tm=150;

char vadr=0;
char vdat[8];
static char str[9];

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
PORTD=0;
PORTB=vadr+(lamp<<5)+(sound<<3)+(pump<<4);
PORTD=vdat[vadr];

vadr++;
if(vadr==8)vadr=0;
if(PINC<255)timr++;
if(PINC==255)timr=0;
if(beep==1)sound++;
}

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
       TCNT1H=0;
       TCNT1L=0;
secnd--;

if(secnd==255)
{
secnd=59;
minut--;
};

if(minut==255)
{
minut=59;
hours--;
};

if(hours==255)hours=23;

}

// Declare your global variables here

char getCode (char ch)
{
    switch (ch)
    {   case '0': return  63;  // "0"
        case '1': return  6;   // "1"
        case '2': return  91;  // "2"
        case '3': return  79;  // "3"
        case '4': return  102; // "4"
        case '5': return  109; // "5"
        case '6': return  125; // "6"
        case '7': return  7;   // "7"
        case '8': return  127; // "8"
        case '9': return  111; // "9"
        case '-': return  64;  // "-"
        case ' ': return  0;   // " "
        case '%': return  36;  // " "
        case 'e': return  121; // "E"
        case 'f': return  113; // "F"
        case 'S': return  109; // "S"
        case 't': return  120; // "t"
        case '': return  99;  // ""
        case 'i': return  16;  // "i"
        case 'u': return  28;  // "u"
        case 'U': return  62;  // "U"
        case 'p': return  115; // "p"
        case 'h': return  116; // "h"
        case 'H': return  118; // "H"
        case 'o': return  92;  // "o"
        case 'r': return  80;  // "r"
        case 'm': return  84;  // "m"
        case 'n': return  84;  // "n"
        case 'c': return  88;  // "c"
        case 'C': return  57;  // "C"
        case 'd': return  94;  // "d"
        case 'a': return  119;  // "a"
        case 'y': return  110;  // "y"
        case '': return  0;  // " "

    }
return 1;
}

void main(void)
{
// Declare your local variables here
char i;

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
PORTB=0x00;
DDRB=0x3F;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Phase correct PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x00;//TCCR2=0x60;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x11;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")
 TCCR0=0x03;
while (1)
      {
      // Place your code here



          sprintf (str,"%2d-%2d-%2d",hours,minut,secnd);

          if (str[0]==' ')str[0]='0';
          if (str[3]==' ')str[3]='0';
          if (str[6]==' ')str[6]='0';

          for(i=0;i<=11;i++)
          {
          vdat[i]=getCode(str[i]);
          };

          if (start==0)
          {
               if (PINB.6==0)
               {
                pump=1;
                delay_ms(5000);
                pump=0;
                timr=0;
                TCCR1B=0x05;
                lamp=1;
                start=1;
                beep=0;
               };

               if(PINC.0==0 & timr==tm)
               {
               timr=0;
               hours++;
               };

               if(PINC.1==0 & timr==tm)
               {
               timr=0;
               hours--;
               };

               if(PINC.2==0 & timr==tm)
               {
               timr=0;
               minut++;
               };

               if(PINC.3==0 & timr==tm)
               {
               timr=0;
               minut--;
               };

               if(PINC.4==0 & timr==tm)
               {
               timr=0;
               secnd++;
               };

               if(PINC.5==0 & timr==tm)
               {
               timr=0;
               secnd--;
               };

               if(hours==24)hours=23;
               if(hours==255)hours=0;
               if(minut==60)minut=59;
               if(minut==255)minut=0;
               if(secnd==60)secnd=59;
               if(secnd==255)secnd=0;
          };
          if (start==1)
          {
               if(hours==0 & minut==0 & secnd==0)
               {
               start=0;
               lamp=0;
               beep=1;
               TCCR1B=0x00;
               };

               if(PINB.7==0)
               {
               timr=0;
               start=0;
               lamp=0;
               TCCR1B=0x00;
               tm++;
               };
          };

      };
};
